
function HoursAndMinutes(ticks)
    local seconds = ticks/TICKS_PER_SECOND
    local minutes = math.floor((seconds)/60)
    local hours = math.floor(minutes/60)
    minutes = minutes - 60 * hours
    return string.format("%3d:%02d", hours, minutes)
end

function StatusCommand_ShowStatus(player, xplayer)
    if xplayer ~= nil then
       local status = string.format("%s played %s of %s. Location %d,%d",
              xplayer.name,
              HoursAndMinutes(xplayer.online_time),
              HoursAndMinutes(game.tick),
              math.floor(xplayer.position.x),
              math.floor(xplayer.position.y));
       game.player.print(status)
    end
end

commands.remove_command("status");
commands.add_command("status", "shows your location, time in game", function(command)
    local players = {}
    for _,p in pairs(game.players) do
        players[_] = p;
    end
    table.sort(players, 
        function(a,b) return a.online_time < b.online_time; end
    );
    
    local player = game.players[command.player_index];
    if player ~= nil then
        if (command.parameter ~= nil) then
            StatusCommand_ShowStatus(player, game.players[command.parameter]);
        else
            for _,xplayer in pairs(players) do
                StatusCommand_ShowStatus(player, xplayer);
            end
        end
    end
end)
